#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

import wx
import string

#------------ VARIABLES GLOBALES --------------------------------------

favicon = "images/coban.ico"
logo = "images/coban.png"

#------------ CLASSES -------------------------------------------------

class ValidDigitPoint(wx.PyValidator):
    """ uniquement des digits et le . """
    def __init__(self):
        wx.PyValidator.__init__(self)
        self.Bind(wx.EVT_CHAR, self.OnChar)

    def Clone(self):
        return ValidDigitPoint()

    def Validate(self, win):
        tc = self.GetWindow()
        val = tc.GetValue()
        
        for x in val:
            if x not in string.digits+".":
                return False
            
        return True

    def OnChar(self, event):
        key = event.GetKeyCode()
        
        if key < wx.WXK_SPACE or key == wx.WXK_DELETE or key > 255:
            event.Skip()
            return
        
        if chr(key) in string.digits+".":
            event.Skip()
            return
        
        if not wx.Validator_IsSilent():
            wx.Bell()
            
        return
    
#------------- DFINITIONS --------------------------------------------

def icone(dlg):
    """ Insre l'icone de l'application sur les fentres cres """
    icon = wx.Icon(favicon, wx.BITMAP_TYPE_ICO)
    dlg.SetIcon(icon)
    
#----------------------------------------------------------------------

def testFloat(entree):
    """
    Teste si la valeur entree peut tre convertie en entier, sinon affiche un messageBox d'erreur.
    Si OK retourne la valeur au format int.
    """
    try:
        val = float(entree.GetValue())
        entree.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_WINDOW))
        entree.Refresh()
        return val
    except :
        wx.MessageBox(u"La valeur entre est incorrecte !", "Erreur")
        entree.SetBackgroundColour("pink")
        entree.SetFocus()
        entree.Refresh()
        return 0

#----------------------------------------------------------------------
